fiar2021/urls.py
from django.contrib import admin
from django.urls import path, include
from fill_the_empty import views
from django.conf.urls.static import static
from django.contrib.staticfiles.storage import staticfiles_storage
from django.views.generic.base import RedirectView
from django.views.generic import TemplateView


from django.conf import settings

urlpatterns = [
    path('accounts/', include('django.contrib.auth.urls')),
    path('admin/', admin.site.urls),
    path('admin_the_empty', views.admin_the_empty,
         name='admin_the_empty'),
    path('', TemplateView.as_view(template_name='post/home.html'),
         name='home'),
    path('fill_the_empty', views.fill_the_empty, name='fill_the_empty'),
    path('one_by_one',
         TemplateView.as_view(template_name='post/one_by_one.html'),
         name='one_by_one'),
    path('video_galery',
         TemplateView.as_view(template_name='post/video_galery.html'),
         name='video_galery'),
    path('json_onebyone', views.json_onebyone, name='json_onebyone'),
    path("favicon.ico", RedirectView.as_view(
        url=staticfiles_storage.url("images/favicon.ico"))),
] 
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
#urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

fill_the_empty/models.py
from django.db import models

# Create your models here.
CHOICES = (
    ('V', 'Valid'),
    ('I', 'Invalid'),
    ('U', 'Unknown'),
)

class Post(models.Model):
    author = models.CharField(max_length=255, default='anónimo')
    pub_date = models.DateTimeField(auto_now_add=True)
    text = models.TextField()
    control = models.CharField(max_length=16, choices=CHOICES, default='U')
    #display_count = models.IntegerField(default=0)
    #image = models.ImageField(upload_to='images/')
 
    def summary(self):
        return self.text[:100]
    def pub_date_pretty(self):
        return self.pub_date.strftime('%b %e, %H:%M')
    def __str__(self):
        return self.author

fill_the_empty/forms.py
from django import forms
from django.contrib.auth.models import User
from .models import Post
from datetime import datetime

class FillTheEmptyForm(forms.ModelForm):
    author = forms.CharField(label='Quem sou eu:', widget=forms.TextInput)
    text = forms.CharField(widget=forms.Textarea,
                           label='', required=True)
    class Meta:
        model = Post
        fields = ('author', 'text')
        exclude = ('control',)


class AdminTheEmptyForm(forms.ModelForm):
    #delete = forms.BooleanField(required=False)
    class Meta:
        model = Post
        fields = ('control', 'author', 'text')#, 'display_count')

fill_the_empty/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponseRedirect, JsonResponse
from .models import Post
from .forms import FillTheEmptyForm, AdminTheEmptyForm
from django.contrib.auth.decorators import login_required
from django.views.decorators.csrf import csrf_protect

# Create your views here.
 
def _onebyone(request):
    pk_current = request.GET.get('pk_current')
    pk_latest = request.GET.get('pk_latest')
    valid_posts = Post.objects.filter(control='V')
    if pk_current is None:
        return valid_posts.first()
    recent_posts = valid_posts.filter(
        pk__gt=pk_current
    )
    if any(recent_posts):
        return recent_posts.first()
    else:
        return valid_posts.first()


def json_onebyone(request):
    post = _onebyone(request)
    data = {'author': post.author, 'text': post.text,
            'pub_date': post.pub_date_pretty(), 'pk': post.pk}
    return JsonResponse(data, content_type="application/json")


def fill_the_empty(request):
    if request.method == 'POST':
        insert_form = FillTheEmptyForm(request.POST)
        if insert_form.is_valid():
            properties = insert_form.save(commit=False)
            properties.user = "anonymous"
            properties.save()
            return HttpResponseRedirect('fill_the_empty')
    else:
        insert_form = FillTheEmptyForm()
    args = {}
    args['request'] = request
    args['form'] = insert_form
    return render(request, 'post/insert_text.html', args)


@login_required
@csrf_protect
def admin_the_empty(request):
    posts = Post.objects
    if request.method == "POST":
        admin_forms = [AdminTheEmptyForm(request.POST, prefix=str(post.id),
                          instance=post) for post in posts.all()]
        if all([v_form.is_valid() for v_form in admin_forms]):
            for admin_form in admin_forms:
                properties = admin_form.save(commit=False)
                print(properties.__dict__)
                properties.user = request.user
                properties.save()
            return HttpResponseRedirect('admin_the_empty')
    else:
        admin_forms = [AdminTheEmptyForm(prefix=str(post.id),
                          instance=post) for post in posts.all()]
    args = {}
    args['request'] = request
    args['forms'] = admin_forms
    return render(request, 'post/admin_text.html', args)

fill_the_empty/templates/post/admin_text.html
{% extends 'post/static_body.html' %}
{% block main %}

  {% block content %}
  <form action = "{%url 'admin_the_empty' %}" method = "POST">
      {% csrf_token %}
      {% for form in  forms %}
          {{ form }} <br />
      {% endfor %}
      <input type = "submit" value = "Submit"/>
  </form>
  {% endblock content %}
  <a href="{% url 'logout' %}">Log Out</a>

{% endblock main %}

fill_the_empty/templates/post/allposts.html
<!doctype html>
<html>
    <body>
            <!--
            <h1>My Post</h1>
            <br /> <br />
            <h2>Latest posts</h2>
            <hr/>-->
            {% for post in  posts.all %}
               <a href="{% url 'detail' post.id %}">  <h3>{{ post.author }}</h3></a>
              {{ post.pub_date_pretty }}
              <br />
                 <!--<img src = "{{ post.image.url }}" height=200 width=200/>
               <br />-->
                 <p>{{ post.summary }}</p>
            {% endfor %}

        &copy; FIAR,  {% now "Y" %}
    </body>
</html>

fill_the_empty/templates/post/autorefresh_body.html
{% extends 'post/base.html' %}
{% block body %}
  <body class="text-white bg-dark">
  {% include 'post/navbar.html' %} 
  <div id="main">
  {% block main %}{% endblock %}
  </div>
  {% include 'post/logo_animation.html' %} 
  {% load static %}
  <script type="text/javascript">

    var pk_current = null;
    var pk_latest = null;

    function data2html (data) {
        $('#ptext').html(data.text.replaceAll("\r\n", "<br \>"));
        $('#pauthor').html(data.author+', ');
        $('#pdate').html(data.pub_date);
        pk_current = data.pk;
        if ( pk_latest == null || pk_current > pk_latest ) {
            pk_latest = pk_current;
        }
    };

    function request2html () {
        let data = {};
        if ( pk_current != null ) {
            data = {'pk_current': pk_current, 'pk_latest': pk_latest};
        }
        $.getJSON("{% url 'json_onebyone' %}", data, data2html);
    };

    function my_log () {
        console.log('hello here!');
    };

    var tl2 = new TimelineLite({
        repeat: -1, repeatDelay: 4
    });

    tl2.to("#post", 1, {}).call(request2html);
   
  </script>

{% endblock body %}

fill_the_empty/templates/post/base.html
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>{% block title %}Fiar2021{% endblock %}</title>

    <!-- Bootstrap -->
    {% load static %}

    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <link href="{% static 'bootstrap/dist/css/bootstrap.min.css' %}" rel="stylesheet">

<!--
    <link href="{% static 'bootstrap-themes/dist/cable/index.min.css' %}" rel="stylesheet">
-->

    <!-- Override with custom CSS --!>
    <link href="{% static 'css/custom.css' %}" rel="stylesheet" type="text/css">


    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script src="{% static 'jquery/dist/jquery.js' %}" type="application/javascript"></script>
    <script src="{% static '@popperjs/core/dist/umd/popper.min.js' %}" type="application/javascript"></script>
    <script src="{% static 'bootstrap/dist/js/bootstrap.min.js' %}" type="application/javascript"></script>
    <script src="{% static 'gsap/dist/gsap.min.js' %}" type="application/javascript"></script>


<!--
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.5.1.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js" integrity="sha384-+YQ4JLhjyBLPDQt//I+STsc9iw4uQqACwlvpslubQzn4u2UU2UFM80nGisd026JF" crossorigin="anonymous"></script>
-->


    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Montserrat:wght@400&display=swap" rel="stylesheet" type='text/css'>

<!--
    <link href='http://fonts.googleapis.com/css?family=Open+Sans' rel='stylesheet'  type='text/css'>

    <style>
      body {
          font-family: 'Open Sans', sans-serif;
      }
    </style>
-->

  </head>
  {% block body %}{% endblock %}
</html>

fill_the_empty/templates/post/detail.html
<!doctype html>
<html>
  <head>
    <title> {{ post.author }}</title>
  </head>
<body>
      <h1> {{ post.author }}</h1>
          <p>{{ post.pub_date }}</p>
      <hr />
      <br />
      <!--<center>
      	<img src = "{{ post.image.url }}"  height=”300” width=”400”/>
      </center>-->
<br />
      <br/>
      <p>{{ post.text }}</p>
      &copy; FIAR,  {% now "Y" %}
  </body>
</html>

fill_the_empty/templates/post/footer.html
<!--
    {% load static %}
    <div class="col-md-8 offset-md-2 text-center">
      <div>
    <img src="{% static 'images/logo_microfiar21.png' %}" alt="logo" width="60%" height="auto"> 
      </div>
    </div>
-->

fill_the_empty/templates/post/home.html
{% extends 'post/static_body.html' %}
{% block main %}

  <div id="intro" class="container">
    <div class="col-md-8 offset-md-2">
      <h1 class="display-5 text-center">Estamos a FIAR o VAZIO!!</h1>
      <hr/>
      <div class="lead text-justify">
        <p>Depois de reconhecer, apreender e experimentar o VAZIO, que se abateu nas nossas vidas, vilas e comunidades, passámos à exploração desse mesmo espaço.</p>
        <p>Encontrámos nesse lugar uma existência que apela à transformação, construção, acção e ocupação. Estás convidado a participar nesta ocupação!</p>
      </div>
    </div>
  </div>

{% endblock main %}

fill_the_empty/templates/post/insert_text.html
{% extends 'post/static_body.html' %}
{% block main %}

  <div id="intro" class="container h-100">
    <div class="row h-100 justify-content-center align-items-center">
    <!--<div class="col-md-8 offset-md-2">-->
      <div class="col-10 col-md-8 col-lg-6">
        <h1 class="display-5">
          Preenche os espaços vazios:
        </h1>
      </div>
    </div>
  </div>
  <hr/>
  <div id="insert_post" class="container h-100">
    <div class="row h-100 justify-content-center align-items-center">
      <div class="col-10 col-md-8 col-lg-6">
        <form action="/fill_the_empty" method="POST">
            {% csrf_token %}
            <p>
              <!--
              <textarea name="text" width="80%" height="auto" required id="id_text">
              </textarea>

              <textarea name="text" cols="40" rows="10" required id="id_text">
              </textarea>
              -->
              <textarea name="text" style="min-width: 100%;"
                        rows="8" required id="id_text">
              </textarea>
            </p>
            <p>
              <label for="id_author">Autor:</label>
              <input type="text" name="author" required id="id_author">
            </p>
            <input type="submit" value="Submeter"/>
        </form>
        <!--
        <form action = "{% url 'fill_the_empty' %}" method = "POST">
          {% csrf_token %}
          {{ form.as_p }}
          <input type="submit" value="Submeter"/>
        </form>
        -->
      </div>
    </div>
  </div>
  <p/>
  <p/>
  <p/>
 {% endblock main %}

fill_the_empty/templates/post/logo_animation.html
  {% load static %}
  <script type="text/javascript">
    var time_duration=4;
    var tl = new TimelineLite;

    tl.set('#main', {css: {display:"none"}})
    .fromTo("#logo", time_duration, {
       css:{src: "{% static 'images/o_of_micro.png' %}"},
       scaleX: 0, scaleY: 0,
    }, {
        rotation: 720,
        transformOrigin: "30% 40%",
        scaleX: 8, scaleY: 8, 
        ease: Expo.easeIn
        /*ease: Elastic.easeOut*/
    })
    .set("#logo", {css: {src: "{% static 'images/logo_microfiar21.png' %}"}})
    .to("#logo", 1, {}) /* Pause 1s */
    .to("#logo", 0.8, {
        transformOrigin: "30% 41%",
        scale: 1, ease: Back.easeOut.config(0.3)
    })
    .set('#main', {css: {display:"block"}});

  </script>

fill_the_empty/templates/post/navbar.html
{% load static %}
<nav class="navbar navbar-default navbar-dark">
<div>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent">
      <span class="navbar-toggler-icon"></span>

  </button>
  <div class="col-md-8 offset-md-2 text-center" href="#">
    <img id="logo" src="{% static 'images/logo_microfiar21.png' %}" alt="MicroFIAR'21" width="60%" height="auto">
    <!--<img id="logo" src="{% static 'images/o_of_micro.png' %}" alt="MicroFIAR'21" width="60%" height="auto">-->
  </div>
</div>
  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li>
        <a class="nav-link" href="{% url 'home' %}">FIAR 2021</a>
      </li>
      <li>
        <a class="nav-link" href="{% url 'video_galery' %}">Ocupação do VAZIO (Vídeos)</a>
      </li>
      <li>
        <a class="nav-link" href="{% url 'one_by_one' %}">Ocupações expontâneas</a>
      </li>
      <li>
        <a class="nav-link" href="{% url 'fill_the_empty' %}">Ocupa tu também</a>
      </li>
    </ul>
  </div>
</nav>
<p/>
<p/>
<p/>

fill_the_empty/templates/post/one_by_one.html
{% extends 'post/autorefresh_body.html' %}
{% block main %}

<div id="post" class="container">
  <div class="col-md-8 offset-md-2">
    <h1 class="display-4">Como FIAS tu o VAZIO?</h1>
    <hr/>
    <h1 id="ptext" class="display-6 fst-italic"></h1>
    <p/>
    <h1>
       <span id="pauthor" class="lead"></span>
       <span id="pdate" class="lead p-3"></span>
    </h1>
  </div>
</div>

{% endblock main %}

fill_the_empty/templates/post/static_body.html
{% extends 'post/base.html' %}
{% block body %}

  <body class="text-white bg-dark">
  {% include 'post/navbar.html' %} 
  <div id="main">
  {% block main %}{% endblock %}
  </div>
  {% include 'post/logo_animation.html' %} 

  </body>

{% endblock body %}

fill_the_empty/templates/post/video_galery.html
{% extends 'post/static_body.html' %}
{% block main %}

  <div id="video_1" class="container">
    <div class="col-xs-8 offset-xs-2">
      <div id="display_video" class="container h-100">
        <div class="row h-100 justify-content-center align-items-center">

            <div class="embed-responsive embed-responsive-16by9">
            <iframe id="ytplayer" type="text/html" 
                src="https://www.youtube.com/embed/qDaoBdQEPq0?autoplay=0"
                frameborder="0" allowfullscreen></iframe>
            </div>
        </div>
      </div>
    </div>
  </div>
  <p/>
  <p/>
  <p/>
  <div id="video_2" class="container">
    <div class="col-xs-8 offset-xs-2">
      <div id="display_video" class="container h-100">
        <div class="row h-100 justify-content-center align-items-center">

            <div class="embed-responsive embed-responsive-16by9">
            <iframe id="ytplayer" type="text/html" 
                src="https://www.youtube.com/embed/OK51S9kiZoQ?autoplay=0"
                frameborder="0" allowfullscreen></iframe>
            </div>
        </div>
      </div>
    </div>
  </div>

{% endblock main %}